<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\FuncionariosHierarqService;
use FM\Traits\TResponse;

class FuncionariosHierarqController
{

    use TResponse;
    protected $FuncionariosHierarqService;

    public function __construct(FuncionariosHierarqService $FuncionariosHierarqService)
    {
        $this->FuncionariosHierarqService = $FuncionariosHierarqService;
    }

    public function getHierarquiaFacilities(Request $request)
    {
        try {
            $data = $this->FuncionariosHierarqService->getHierarquiaFacilities($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
