<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class FuncionariosHierarqFactory
{
    use TQuery;

    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
    }

    public function getHierarquiaFacilities($parametros)
    {

        $sql = "SELECT A.CDOPERADOR
                    FROM FCM_FUNCIONARIOSHIERARQ A
                    JOIN OPERADOR B ON B.CDOPERADOR = A.CDOPERADOR
                    JOIN FCM_HIERARQUIAFUNC H ON H.NRHIERARQUIAFUNC = A.NRHIERARQUIAFUNC
                WHERE A.NRHIERARQUIAFUNC = (SELECT NRHIERARQUIAFUNC
                                                FROM FCM_HIERARQUIAFUNC
                                                WHERE IDATIVO = 'S')
                    AND A.CDOPERADOR IN (SELECT CDOPERADOR
                                                    FROM FCM_FUNCIONARIOSHIERARQ F
                                                    JOIN FCM_HIERARQUIAFUNC H
                                                    ON F.NRHIERARQUIAFUNC = H.NRHIERARQUIAFUNC AND H.IDATIVO = 'S'
                                                    START WITH CDOPERADOR     = :CDOPERADOR
                                                    CONNECT BY PRIOR CDOPERADOR = CDOPERADORPAI)";

        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }
}
