CREATE OR REPLACE PROCEDURE ARQUIVO_GIA_ICMS_ST(
   P_CDIMPOSTO    IN MAPAAPURAC.CDIMPOSTO%TYPE,
   P_CDEMPRESA    IN MAPAAPURAC.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN MAPAAPURAC.CDINSCESTA%TYPE,
   P_CDINSCESTAST IN MAPAAPURAC.CDINSCESTA%TYPE,
   P_DTINICIAL    IN MAPAAPURAC.DTINIPERIODO%TYPE,
   P_DTFINAL      IN MAPAAPURAC.DTFIMPERIODO%TYPE,
   P_OPTRANSFER   IN NOTAFISCAL.IDSTATUS%TYPE,
   P_MOVIMENTO    IN NOTAFISCAL.IDSTATUS%TYPE,
   P_RETIFICACAO  IN NOTAFISCAL.IDSTATUS%TYPE,
   P_VERSAO       IN ITMAPARECUP.IDTIPOITMAPR%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE)
AS
   V_NRSEQUMAPAPU    VARCHAR2(10);
   V_DADOSREG0       VARCHAR2(1000);
   V_CONTREGA1       NUMBER;
   V_CONTREGA2       NUMBER;
   V_CONTREGA3       NUMBER;
   V_NRTAMTEL        NUMBER;
   V_NRPOSTEL        NUMBER;
BEGIN
   V_CONTREGA1 := 0;
   V_CONTREGA2 := 0;
   V_CONTREGA3 := 0;

   BEGIN
      SELECT NRSEQUMAPAPU
        INTO V_NRSEQUMAPAPU
        FROM MAPAAPURAC M, INSCRESTADST I
       WHERE I.CDEMPRESA    = P_CDEMPRESA
         AND I.CDINSCESTA   = P_CDINSCESTA
         AND I.CDINSCESTAST = P_CDINSCESTAST
         AND M.CDEMPRESA    = I.CDEMPRESA
         AND M.CDINSCESTA   = I.CDINSCESTA
         AND M.CDIMPOSTO    = P_CDIMPOSTO
         AND M.DTINIPERIODO = P_DTINICIAL
         AND M.DTFIMPERIODO = P_DTFINAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_NRSEQUMAPAPU := NULL;
   END;

   IF P_VERSAO = '02' THEN
      V_NRTAMTEL := 12;
      V_NRPOSTEL := 8;
   ELSE
      V_NRTAMTEL := 13;
      V_NRPOSTEL := 9;
   END IF;

   /*Registro Principal*/
   BEGIN
      SELECT ('A0'                                                       ||
             'GST'                                                       ||
             RPAD(P_VERSAO,2,' ')                                        ||
             TO_CHAR(TO_DATE(P_DTINICIAL),'MMYYYY')                      ||
             RPAD(P_CDINSCESTAST,14,' ')                                 ||
             DECODE(P_VERSAO,'02',DECODE(P_MOVIMENTO,  'N','X',' '), DECODE(P_MOVIMENTO,'N','S','N')) ||
             DECODE(P_VERSAO,'02',DECODE(P_RETIFICACAO,'S','X',' '), P_RETIFICACAO) ||
             NVL(TO_CHAR(DTVENCGUIA,'YYYYMMDD'),'00000000')              ||
             LTRIM(REPLACE(TO_CHAR(CASE WHEN (IMP_ICMSST-ST_DEVOL-ST_RESSARC-VRSLDCRANTE-PAG_ANTEC) < 0
                                        THEN 0 ELSE (IMP_ICMSST-ST_DEVOL-ST_RESSARC-VRSLDCRANTE-PAG_ANTEC)   END,'0000000000000.00'),'.')) ||
             LPAD('0',8,'0')                                             ||
             LPAD('0',15,'0')                                            ||
             LPAD('0',8,'0')                                             ||
             LPAD('0',15,'0')                                            ||
             LPAD('0',8,'0')                                             ||
             LPAD('0',15,'0')                                            ||
             LPAD('0',8,'0')                                             ||
             LPAD('0',15,'0')                                            ||
             LPAD('0',8,'0')                                             ||
             LPAD('0',15,'0')                                            ||
             SGESTADO                                                    ||
             LTRIM(REPLACE(TO_CHAR(VRPRODUTO,  '0000000000000.00'),'.')) ||
             LTRIM(REPLACE(TO_CHAR(IPI,        '0000000000000.00'),'.')) ||
             LTRIM(REPLACE(TO_CHAR(DESP_ACESS, '0000000000000.00'),'.')) ||
             LTRIM(REPLACE(TO_CHAR(BC_ICMS,    '0000000000000.00'),'.')) ||
             LTRIM(REPLACE(TO_CHAR(IMP_ICMS,   '0000000000000.00'),'.')) ||
             LTRIM(REPLACE(TO_CHAR(BC_ICMSST,  '0000000000000.00'),'.')) ||
             LTRIM(REPLACE(TO_CHAR(IMP_ICMSST, '0000000000000.00'),'.')) ||
             LTRIM(REPLACE(TO_CHAR(ST_DEVOL,   '0000000000000.00'),'.')) ||
             LTRIM(REPLACE(TO_CHAR(ST_RESSARC, '0000000000000.00'),'.')) ||
             LTRIM(REPLACE(TO_CHAR(VRSLDCRANTE,'0000000000000.00'),'.')) ||
             LTRIM(REPLACE(TO_CHAR(PAG_ANTEC,  '0000000000000.00'),'.')) ||
             LTRIM(REPLACE(TO_CHAR(CASE WHEN (IMP_ICMSST-ST_DEVOL-ST_RESSARC-VRSLDCRANTE-PAG_ANTEC) < 0
                                        THEN 0 ELSE (IMP_ICMSST-ST_DEVOL-ST_RESSARC-VRSLDCRANTE-PAG_ANTEC)   END,'0000000000000.00'),'.')) ||
             LPAD('0',15,'0')                                            ||
             LTRIM(REPLACE(TO_CHAR(CASE WHEN ((ST_DEVOL+ST_RESSARC+VRSLDCRANTE+PAG_ANTEC)-IMP_ICMSST) < 0
                                        THEN 0 ELSE ((ST_DEVOL+ST_RESSARC+VRSLDCRANTE+PAG_ANTEC)-IMP_ICMSST) END,'0000000000000.00'),'.')) ||
             LTRIM(REPLACE(TO_CHAR(CASE WHEN (IMP_ICMSST-ST_DEVOL-ST_RESSARC-VRSLDCRANTE-PAG_ANTEC) < 0
                                        THEN 0 ELSE (IMP_ICMSST-ST_DEVOL-ST_RESSARC-VRSLDCRANTE-PAG_ANTEC)   END,'0000000000000.00'),'.')) ||
             CNPJ                                                        ||
             RPAD(NM_DECLARANTE,46,' ')                                  ||
             LPAD(CPF_DECLARANTE,11,'0')                                 ||
             RPAD(CARGO_DECLARANTE,30,' ')                               ||
             SUBSTR(LPAD(TEL_DECLARANTE,V_NRTAMTEL,'0'),1,4)             ||
             SUBSTR(LPAD(TEL_DECLARANTE,V_NRTAMTEL,'0'),5,V_NRPOSTEL)    ||
             SUBSTR(LPAD(FAX_DECLARANTE,V_NRTAMTEL,'0'),1,4)             ||
             SUBSTR(LPAD(FAX_DECLARANTE,V_NRTAMTEL,'0'),5,V_NRPOSTEL)    ||
             RPAD(EMAIL_DECLARANTE,DECODE(P_VERSAO,'02',40,80),' ')      ||
             RPAD(LOCAL,30,' ')                                          ||
             TO_CHAR(SYSDATE,'YYYYMMDD')                                 ||
             LPAD(' ',DECODE(P_VERSAO,'02',60,65),' ')                   ||
             LPAD(' ',60,' ')                                            ||
             LPAD(' ',60,' ')                                            ||
             'N'                                                         )AS DADOS1
        INTO V_DADOSREG0
        FROM (SELECT MP.DTVENCGUIA AS DTVENCGUIA, MP.VRTOTAGUIA AS VRTOTAGUIA,
                     NVL(IST.SGESTADO,IE.SGESTADO) AS SGESTADO,
                     SUM(NVL(DECODE(IP.IDENTRSAIDOP,'S',VRTOTAITEM,0),0)) AS VRPRODUTO,
                     SUM(NVL(DECODE(IP.IDENTRSAIDOP,'S',VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF,II.NRSEQITPROD,'10','I','1'),0),0)) AS IPI,
                     SUM(NVL(IP.DESPESAS,0)) AS DESP_ACESS,
                     SUM(NVL(DECODE(IP.IDENTRSAIDOP,'S', CASE WHEN CDFISCOPERIT IN ('5109','5110','6109','6110')
                               THEN VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF,II.NRSEQITPROD,'00','B')
                               ELSE VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF,II.NRSEQITPROD,'00','B','1') END,0),0)) AS BC_ICMS,
                     SUM(NVL(DECODE(IP.IDENTRSAIDOP,'S', CASE WHEN CDFISCOPERIT IN ('5109','5110','6109','6110')
                               THEN VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF,II.NRSEQITPROD,'00','I')
                               ELSE VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL, IP.NRLANCTONF,II.NRSEQITPROD,'00','I','1') END,0),0)) AS IMP_ICMS,
                     SUM(NVL(DECODE(IP.IDENTRSAIDOP,'S',DECODE(II.CDFISCALIT,'1',II.VRBASECALCIT,0),0),0)) AS BC_ICMSST,
                     SUM(NVL(DECODE(IP.IDENTRSAIDOP,'S',DECODE(II.CDFISCALIT,'1',II.VRIMPOSTOIT,0),0),0)) AS IMP_ICMSST,
                     SUM(NVL(DECODE(IP.IDENTRSAIDOP,'E',DECODE(CP.IDTIPOCFOP,'D',DECODE(II.CDFISCALIT,'1',II.VRIMPOSTOIT,0),0),0),0)) AS ST_DEVOL,
                     SUM(NVL(DECODE(IP.IDENTRSAIDOP,'E',CASE WHEN II.CDFISCOPERIT IN ('1603','2603') THEN DECODE(II.CDFISCALIT,'1',II.VRIMPOSTOIT,0) ELSE 0 END,0),0)) AS ST_RESSARC,
                     MR.VRSLDCRANTE,
                     (SELECT NVL(SUM(VRITEMMAPR),0)
                        FROM ITMAPARECUP
                       WHERE IDTIPOITMAPR = 'OC'
                         AND NRSEQUMAPAPU = V_NRSEQUMAPAPU
                         AND DSITEMMAPR LIKE 'ANTECIPADO ICMS-ST%') AS PAG_ANTEC,
                     REPLACE(REPLACE(REPLACE(REPLACE(IE.NRINSJURIEST,'.',''),'-',''),'/',''),' ','') AS CNPJ,
                     CO.NMRESPONSAVL AS NM_DECLARANTE, CO.NRCPFRESPONS AS CPF_DECLARANTE, 'Contador' AS CARGO_DECLARANTE,
                     NVL(REPLACE(REPLACE(REPLACE(REPLACE(CO.NRTELCONTATO,' '),')'),'('),'-'),'0') AS TEL_DECLARANTE,
                     NVL(REPLACE(REPLACE(REPLACE(REPLACE(CO.NRFAXCONTATO,' '),')'),'('),'-'),'0') AS FAX_DECLARANTE,
                     NVL(CO.DSENDINTERN,' ') AS EMAIL_DECLARANTE, ES.NMESTADO AS LOCAL
                FROM MAPAAPURAC MP, INSCRESTAD IE, CFOPPADRAO CP, MAPARECUP MR, CONTADOR CO,
                     ESTADO ES, ITEMPRODUTO IT, ITEMPROIMPOS II, IMPOSTO IM, INSCRESTADST IST,
                     (SELECT DISTINCT NF.CDFILIAL, NF.NRLANCTONF, NF.IDENTRSAIDOP,
                             DECODE(NF.IDENTRSAIDOP,'S',VALOR_ENCARGO(NF.CDFILIAL, NF.NRLANCTONF, 'A'),0) AS DESPESAS
                        FROM IMPOSTONF IP, NOTAFISCAL NF
                       WHERE IP.NRSEQUMAPAPU = V_NRSEQUMAPAPU
                         AND NF.NRLANCTONF   = IP.NRLANCTONF
                         AND NF.CDFILIAL     = IP.CDFILIAL
                         AND NF.CDINSCESTAST = P_CDINSCESTAST) IP
               WHERE MP.NRSEQUMAPAPU  = V_NRSEQUMAPAPU
                 AND MP.CDINSCESTA    = IE.CDINSCESTA
                 AND IST.CDEMPRESA    = MP.CDEMPRESA
                 AND IST.CDINSCESTA   = MP.CDINSCESTA
                 AND IST.CDINSCESTAST = P_CDINSCESTAST
                 AND II.CDFISCOPERIT  = CP.CDCFOPPADRAO(+)
                 AND MP.NRSEQUMAPAPU  = MR.NRSEQUMAPAPU
                 AND IE.CDCONTADOR2   = CO.CDCONTADOR2
                 AND IE.SGESTADO      = ES.SGESTADO
                 AND IP.NRLANCTONF    = II.NRLANCTONF
                 AND IP.CDFILIAL      = II.CDFILIAL
                 AND II.NRLANCTONF    = IT.NRLANCTONF
                 AND II.CDFILIAL      = IT.CDFILIAL
                 AND II.NRSEQITPROD   = IT.NRSEQITPROD
                 AND IM.CDIMPOSTO     = II.CDIMPOSTO
                 AND IM.CDIMPOSTONFE  = P_CDIMPOSTO
                 AND II.VRIMPOSTOIT   > 0
               GROUP BY MP.DTVENCGUIA, MP.VRTOTAGUIA, NVL(IST.SGESTADO,IE.SGESTADO), MR.VRSLDCRANTE,
                        REPLACE(REPLACE(REPLACE(REPLACE(IE.NRINSJURIEST,'.',''),'-',''),'/',''),' ',''),
                        CO.NMRESPONSAVL, CO.NRCPFRESPONS, CO.NRTELCONTATO, CO.NRTELCONTATO, CO.NRFAXCONTATO,
                        CO.NRFAXCONTATO, CO.DSENDINTERN, ES.NMESTADO);
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_DADOSREG0 := NULL;
   END;

   IF V_DADOSREG0 IS NULL THEN
      BEGIN
         SELECT ('A0'                                                       ||
                'GST'                                                       ||
                RPAD(P_VERSAO,2,' ')                                        ||
                TO_CHAR(TO_DATE(P_DTINICIAL),'MMYYYY')                      ||
                RPAD(P_CDINSCESTAST,14,' ')                                 ||
                DECODE(P_VERSAO,'02',DECODE(P_MOVIMENTO,  'N','X',' '), DECODE(P_MOVIMENTO,'N','S','N')) ||
                DECODE(P_VERSAO,'02',DECODE(P_RETIFICACAO,'S','X',' '), P_RETIFICACAO) ||
                LPAD('0',8,'0')                                             ||
                LPAD('0',15,'0')                                            ||
                LPAD('0',8,'0')                                             ||
                LPAD('0',15,'0')                                            ||
                LPAD('0',8,'0')                                             ||
                LPAD('0',15,'0')                                            ||
                LPAD('0',8,'0')                                             ||
                LPAD('0',15,'0')                                            ||
                LPAD('0',8,'0')                                             ||
                LPAD('0',15,'0')                                            ||
                LPAD('0',8,'0')                                             ||
                LPAD('0',15,'0')                                            ||
                SGESTADO                                                    ||
                LPAD('0',15,'0')                                            ||
                LPAD('0',15,'0')                                            ||
                LPAD('0',15,'0')                                            ||
                LPAD('0',15,'0')                                            ||
                LPAD('0',15,'0')                                            ||
                LPAD('0',15,'0')                                            ||
                LPAD('0',15,'0')                                            ||
                LPAD('0',15,'0')                                            ||
                LPAD('0',15,'0')                                            ||
                LTRIM(REPLACE(TO_CHAR(NVL(VRSLDCRANTE,0),'0000000000000.00'),'.')) ||
                LTRIM(REPLACE(TO_CHAR(NVL(PAG_ANTEC,0),  '0000000000000.00'),'.')) ||
                LPAD('0',15,'0')                                            ||
                LPAD('0',15,'0')                                            ||
                LTRIM(REPLACE(TO_CHAR(NVL(VRSLDCRANTE,0)+NVL(PAG_ANTEC, 0),'0000000000000.00'),'.')) ||
                LPAD('0',15,'0')                                            ||
                CNPJ                                                        ||
                RPAD(NM_DECLARANTE,46,' ')                                  ||
                LPAD(CPF_DECLARANTE,11,'0')                                 ||
                RPAD(CARGO_DECLARANTE,30,' ')                               ||
                SUBSTR(LPAD(TEL_DECLARANTE,V_NRTAMTEL,'0'),1,4)             ||
                SUBSTR(LPAD(TEL_DECLARANTE,V_NRTAMTEL,'0'),5,V_NRPOSTEL)    ||
                SUBSTR(LPAD(FAX_DECLARANTE,V_NRTAMTEL,'0'),1,4)             ||
                SUBSTR(LPAD(FAX_DECLARANTE,V_NRTAMTEL,'0'),5,V_NRPOSTEL)    ||
                RPAD(EMAIL_DECLARANTE,DECODE(P_VERSAO,'02',40,80),' ')      ||
                RPAD(LOCAL,30,' ')                                          ||
                TO_CHAR(SYSDATE,'YYYYMMDD')                                 ||
                LPAD(' ',DECODE(P_VERSAO,'02',60,65),' ')                   ||
                LPAD(' ',60,' ')                                            ||
                LPAD(' ',60,' ')                                            ||
                'N'                                                         )AS DADOS1
           INTO V_DADOSREG0
           FROM (SELECT MP.DTVENCGUIA AS DTVENCGUIA, MP.VRTOTAGUIA AS VRTOTAGUIA, NVL(IST.SGESTADO, IE.SGESTADO) AS SGESTADO,
                        MR.VRSLDCRANTE,
                        (SELECT NVL(SUM(VRITEMMAPR),0)
                           FROM ITMAPARECUP
                          WHERE IDTIPOITMAPR = 'OC'
                            AND NRSEQUMAPAPU = V_NRSEQUMAPAPU
                            AND DSITEMMAPR LIKE 'ANTECIPADO ICMS-ST%') AS PAG_ANTEC,
                        REPLACE(REPLACE(REPLACE(REPLACE(IE.NRINSJURIEST,'.',''),'-',''),'/',''),' ','') AS CNPJ,
                        CO.NMRESPONSAVL AS NM_DECLARANTE, CO.NRCPFRESPONS AS CPF_DECLARANTE, 'Contador' AS CARGO_DECLARANTE,
                        NVL(REPLACE(REPLACE(REPLACE(REPLACE(CO.NRTELCONTATO,' '),')'),'('),'-'),'0') AS TEL_DECLARANTE,
                        NVL(REPLACE(REPLACE(REPLACE(REPLACE(CO.NRFAXCONTATO,' '),')'),'('),'-'),'0') AS FAX_DECLARANTE,
                        NVL(CO.DSENDINTERN,' ') AS EMAIL_DECLARANTE, ES.NMESTADO AS LOCAL
                   FROM MAPAAPURAC MP, INSCRESTAD IE, INSCRESTADST IST, MAPARECUP MR, CONTADOR CO, ESTADO ES
                  WHERE MP.NRSEQUMAPAPU = V_NRSEQUMAPAPU
                    AND MP.CDINSCESTA   = IE.CDINSCESTA
                    AND MP.NRSEQUMAPAPU = MR.NRSEQUMAPAPU
                    AND IE.CDCONTADOR2  = CO.CDCONTADOR2
                    AND IE.SGESTADO     = ES.SGESTADO
                    AND MP.CDEMPRESA    = IST.CDEMPRESA(+)
                    AND MP.CDINSCESTA   = IST.CDINSCESTA(+)
                    AND P_CDINSCESTAST  = IST.CDINSCESTAST(+));
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_DADOSREG0 := NULL;
      END;
   END IF;

   /*Anexo I - ICMS de Devolues de Mercadorias*/
   FOR C_REGA1 IN (SELECT 'A1'                                    ||
                          DECODE(P_VERSAO,'02',SUBSTR(LPAD(NF.NRNOTAFISC,20,'0'),13,8),SUBSTR(LPAD(NF.NRNOTAFISC,20,'0'),8,13)) ||
                          RPAD(NF.CDSERIEENTR,3,' ')              ||
                          RPAD(DECODE(IDORIGDESTNF,'C',CL.NRINSESTCLIE,FO.NRINSESTFORN),14,' ') ||
                          TO_CHAR(NF.DTEMISSAO,'YYYYMMDD')        ||
                          LTRIM(REPLACE(TO_CHAR(SUM(DECODE(CDFISCALNF,'1',VRIMPOSTONF,0)),'0000000000000.00'),'.')) AS DADOS
                     FROM NOTAFISCAL NF, IMPOSTONF IP, CFOPPADRAO CP, CLIENTE CL, FORNECEDOR FO
                    WHERE NF.NRLANCTONF    = IP.NRLANCTONF
                      AND NF.CDFILIAL      = IP.CDFILIAL
                      AND NF.CDINSCESTAST  = P_CDINSCESTAST
                      AND NF.IDENTRSAIDOP  = 'E'
                      AND IP.NRSEQUMAPAPU  = V_NRSEQUMAPAPU
                      AND IP.CDFISCOPERNF  = CP.CDCFOPPADRAO
                      AND CP.IDTIPOCFOP    = 'D'
                      AND DECODE(CDFISCALNF,'1',VRIMPOSTONF,0) > 0
                      AND CL.CDCLIENTE(+)  = NF.CDCLIENTE
                      AND FO.CDFORNECED(+) = NF.CDFORNECED
                    GROUP BY NF.NRNOTAFISC, NF.CDSERIEENTR, DECODE(IDORIGDESTNF,'C',CL.NRINSESTCLIE,FO.NRINSESTFORN),NF.DTEMISSAO) LOOP
      V_CONTREGA1 := NVL(V_CONTREGA1,0) + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('A1'||LPAD(RTRIM(V_CONTREGA1),8,'0'), C_REGA1.DADOS, P_NRSEQARQMAG);
   END LOOP;

   /*Anexo II - ICMS de Ressarcimentos*/
   FOR C_REGA2 IN (SELECT 'A2'                                    ||
                          DECODE(P_VERSAO,'02',SUBSTR(LPAD(NF.NRNOTAFISC,20,'0'),13,8),SUBSTR(LPAD(NF.NRNOTAFISC,20,'0'),8,13)) ||
                          RPAD(NF.CDSERIEENTR,3,' ')              ||
                          RPAD(DECODE(NF.IDORIGDESTNF,'C',CL.NRINSESTCLIE,FO.NRINSESTFORN),14,' ')   ||
                          TO_CHAR(NF.DTEMISSAO,'YYYYMMDD')        ||
                          LTRIM(REPLACE(TO_CHAR(SUM(DECODE(IP.CDFISCALNF,'1',IP.VRIMPOSTONF,0)),'0000000000000.00'),'.')) AS DADOS
                     FROM NOTAFISCAL NF, IMPOSTONF IP, CLIENTE CL, FORNECEDOR FO
                    WHERE NF.NRLANCTONF   = IP.NRLANCTONF
                      AND NF.CDFILIAL     = IP.CDFILIAL
                      AND NF.CDINSCESTAST = P_CDINSCESTAST
                      AND NF.IDENTRSAIDOP = 'E'
                      AND IP.NRSEQUMAPAPU = V_NRSEQUMAPAPU
                      AND IP.CDFISCOPERNF IN ('1603', '2603')
                      AND NF.CDCLIENTE    = CL.CDCLIENTE(+)
                      AND NF.CDFORNECED   = FO.CDFORNECED(+)
                      AND DECODE(IP.CDFISCALNF,'1',IP.VRIMPOSTONF,0) > 0
                    GROUP BY NF.NRNOTAFISC, NF.CDSERIEENTR, DECODE(NF.IDORIGDESTNF,'C',CL.NRINSESTCLIE,FO.NRINSESTFORN), NF.DTEMISSAO) LOOP
      V_CONTREGA2 := NVL(V_CONTREGA2,0) + 1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('A2'||LPAD(RTRIM(V_CONTREGA2),8,'0'), C_REGA2.DADOS, P_NRSEQARQMAG);
   END LOOP;

   /*Anexo III - Transferncias efetuadas*/
   IF P_OPTRANSFER = 'R' THEN
      FOR C_REGA3 IN( SELECT 'A3'                        ||
                             RPAD(FI.CDINSCESTA,14,' ')  ||
                             LTRIM(REPLACE(TO_CHAR(SUM(DECODE(IP.CDFISCALNF,'1',IP.VRBASECALCNF,0)),'0000000000000.00'),'.')) ||
                             LTRIM(REPLACE(TO_CHAR(SUM(DECODE(IP.CDFISCALNF,'1',IP.VRIMPOSTONF,0)),'0000000000000.00'),'.')) AS DADOS
                        FROM NOTAFISCAL NF, IMPOSTONF IP, FILIAL FI
                       WHERE NF.NRLANCTONF   = IP.NRLANCTONF
                         AND NF.CDFILIAL     = IP.CDFILIAL
                         AND NF.CDINSCESTAST = P_CDINSCESTAST
                         AND NF.IDENTRSAIDOP = 'S'
                         AND NF.IDORIGDESTNF = 'L'
                         AND IP.NRSEQUMAPAPU = V_NRSEQUMAPAPU
                         AND DECODE(IP.CDFISCALNF,'1',IP.VRIMPOSTONF,0) > 0
                         AND NF.CDFILIRECE   = FI.CDFILIAL
                       GROUP BY FI.CDINSCESTA) LOOP
         V_CONTREGA3 := NVL(V_CONTREGA3,0) + 1;
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('A3'||LPAD(RTRIM(V_CONTREGA3),8,'0'), C_REGA3.DADOS, P_NRSEQARQMAG);
      END LOOP;
   ELSE
       FOR C_REGA3 IN(SELECT 'A3'                        ||
                             RPAD(FI.CDINSCESTA,14,' ')  ||
                             LTRIM(REPLACE(TO_CHAR(SUM(VALOR_IMPOSTO_ITEM_NFE(IT.CDFILIAL,IT.NRLANCTONF,IT.NRSEQITPROD, '00','B','1')),'0000000000000.00'),'.')) ||
                             LTRIM(REPLACE(TO_CHAR(SUM(VALOR_IMPOSTO_ITEM_NFE(IT.CDFILIAL,IT.NRLANCTONF,IT.NRSEQITPROD, '00','I','1')),'0000000000000.00'),'.')) AS DADOS
                        FROM ITEMPROIMPOS IT, IMPOSTO IM, FILIAL FI,
                             (SELECT DISTINCT NF.CDFILIAL, NF.NRLANCTONF, NF.CDFILIRECE
                                FROM IMPOSTONF IP, NOTAFISCAL NF
                                WHERE NF.NRLANCTONF = IP.NRLANCTONF
                                AND NF.CDFILIAL     = IP.CDFILIAL
                                AND NF.CDINSCESTAST = P_CDINSCESTAST
                                AND NF.IDENTRSAIDOP = 'S'
                                AND NF.IDORIGDESTNF = 'L'
                                AND IP.NRSEQUMAPAPU = V_NRSEQUMAPAPU
                                AND DECODE(IP.CDFISCALNF,'1',IP.VRIMPOSTONF,0) > 0) N
                       WHERE IT.CDFILIAL     = N.CDFILIAL
                         AND IT.NRLANCTONF   = N.NRLANCTONF
                         AND N.CDFILIRECE    = FI.CDFILIAL
                         AND IT.CDIMPOSTO    = IM.CDIMPOSTO
                         AND IM.CDIMPOSTONFE = '80'
                       GROUP BY FI.CDINSCESTA) LOOP
         V_CONTREGA3 := NVL(V_CONTREGA3,0) + 1;
         INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
           ('A3'||LPAD(RTRIM(V_CONTREGA3),8,'0'), C_REGA3.DADOS, P_NRSEQARQMAG);
      END LOOP;
   END IF;

   V_DADOSREG0 := V_DADOSREG0 ||
                  CASE WHEN V_CONTREGA3 > 0 THEN 'S' ELSE 'N' END ||
                  LPAD(' ',6,' ') ||
                  LPAD(V_CONTREGA1,CASE WHEN P_VERSAO = '02' THEN 4 ELSE 6 END,'0') ||
                  LPAD(V_CONTREGA2,CASE WHEN P_VERSAO = '02' THEN 4 ELSE 6 END,'0') ||
                  LPAD(V_CONTREGA3,CASE WHEN P_VERSAO = '02' THEN 4 ELSE 6 END,'0') ||
                  LPAD('0',15,'0');

   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('A0'||LPAD('0',8,'0'), V_DADOSREG0, P_NRSEQARQMAG);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_GIA_ICMS_ST','5.67.000'); END;
/


