import { ZdPage } from '@zeedhi/vue';
import { ZdFramePage } from '@zeedhi/vuetify';

const routes = [
    {
        path: '/',
        name: 'home',
        component: () => import('../views/Home.vue'),
    },
    {
        path: '/auth/login',
        name: 'login',
        component: ZdPage,
        props: {
            path: 'login',
            local: true,
        },
    },
    {
        path: '/',
        name: 'home',
        component: ZdPage,
        props: () => ({
            path: 'home',
            local: true,
        }),
    },
    {
        path: '/modules/:module/:page',
        name: 'microservice',
        component: () => import('../views/Microservice.vue'),
    },
    {
        path: '*',
        component: ZdPage,
        props: {
            path: 'notfound',
            local: true,
        },
    },
    {
        path: '/fm_00001_001_listagem_tarefas',
        name: 'Listagem de Tarefas',
        component: ZdFramePage,
        props: {
            type: 'post',
            params: {
                jsonPath: 'fm_00001_000_tarefas/fm_00001_001_listagem_tarefas',
                routePath: '/fm_00001_001_listagem_tarefas',
            },
        },
    },
    {
        path: '/fm_00001_000_tarefas',
        name: 'Minhas Tarefas',
        component: ZdFramePage,
        props: {
            type: 'post',
            params: {
                jsonPath: 'fm_00001_000_tarefas/fm_00001_000_tarefas',
                routePath: '/fm_00001_000_tarefas',
            },
        },
    },
    {
        path: '/fm_00011_000_analise_nao_conformidade',
        name: 'Análise de Não Conformidades',
        component: ZdFramePage,
        props: {
            type: 'post',
            params: {
                jsonPath: 'fm_00011_000_analise_nao_conformidade/fm_00011_000_analise_nao_conformidade',
                routePath: '/fm_00011_000_analise_nao_conformidade',
            },
        },
    },
    {
        path: '/fm_00001_000_detalhamento_tarefa',
        name: 'Detalhes Tarefa',
        component: ZdFramePage,
        props: {
            type: 'post',
            params: {
                jsonPath: 'fm_00001_000_tarefas/fm_00001_000_detalhamento_tarefa',
                routePath: '/fm_00001_000_detalhamento_tarefa',
            },
        },
    },
    {
        path: '/fm_00001_000_reportar_tarefa',
        name: 'Reportar Tarefa',
        component: ZdFramePage,
        props: {
            type: 'post',
            params: {
                jsonPath: 'fm_00001_000_tarefas/fm_00001_000_reportar_tarefa',
                routePath: '/fm_00001_000_reportar_tarefa',
            },
        },
    },
    {
        path: '/fm_00000_000_dashboard',
        name: 'Dashboard',
        component: ZdFramePage,
        props: {
            type: 'post',
            params: {
                jsonPath: 'fm_00000_000_dashboard/fm_00000_000_dashboard',
                routePath: '/fm_00000_000_dashboard',
            },
        },
    },
    {
        path: '/fm_00002_000_vistoria',
        name: 'Listagem de Vistorias',
        component: ZdFramePage,
        props: {
            type: 'post',
            params: {
                jsonPath: 'fm_00002_000_vistoria/fm_00002_000_vistoria',
                routePath: '/fm_00002_000_vistoria',
            },
        },
    },
    {
        path: '/fm_00000_000_calendario',
        name: 'Calendario',
        component: ZdPage,
        props: () => ({
            path: 'fm_00000_000_calendario/fm_00000_000_calendario',
            local: true,
        }),
    },
    {
        path: '/registrarApontamento',
        name: 'Registrar_Apontamento',
        component: ZdPage,
        props: () => ({
            path: 'registrarApontamento',
            local: true,
        }),
    },
    {
        path: '/fm_00021_000_registrar_apontamento',
        name: 'Registrar Apontamento',
        component: ZdFramePage,
        props: {
            type: 'post',
            params: {
                jsonPath: 'fm_00021_000_apontamento/fm_00021_000_registrar_apontamento',
                routePath: '/fm_00021_000_registrar_apontamento',
            },
        },
    },
    {
        path: '/fm_00020_000_solicitacoes',
        name: 'Solicitações',
        component: ZdFramePage,
        props: {
            type: 'post',
            params: {
                jsonPath: 'fm_00020_000_solicitacoes/fm_00020_000_solicitacoes',
                routePath: '/fm_00020_000_solicitacoes',
            },
        },
    },
    {
        path: '/fm_00021_001_registrar_falta',
        name: 'Registrar Falta',
        component: ZdFramePage,
        props: {
            type: 'post',
            params: {
                jsonPath: 'fm_00021_000_apontamento/fm_00021_001_registrar_falta',
                routePath: '/fm_00021_001_registrar_falta',
            },
        },
    },
    {
        path: '/solicitacaoTarefa',
        name: 'Solicitacao_Tarefaa',
        component: ZdPage,
        props: () => ({
            path: 'solicitacaoTarefa',
            local: true,
        }),
    },
    {
        path: '/criarSolicitacao',
        name: 'criar_solicitacao',
        component: ZdPage,
        props: () => ({
            path: 'criarSolicitacaoTarefa',
            local: true,
        }),
    },
    {
        path: '/avaliarSolicitacao',
        name: 'avaliar_solicitacao',
        component: ZdPage,
        props: () => ({
            path: 'avaliarSolicitacao',
            local: true,
        }),
    },
    {
        path: '*',
        component: ZdPage,
        props: {
            path: 'notfound',
            local: true,
        },
    },
];

export default routes;
